/* $Id: atoms.c,v 1.5 2004/11/19 06:12:15 ppl Exp $ */

/*
	This file is purely Xlib/X11 code
*/

#include "xsfcave.h"

int
atoms_init(void)
{
	int rtn;
	size_t i;

	char const * const names[] =
	{
		"ATOM"               ,
		"WM_DELETE_WINDOW"   ,
		"WM_PROTOCOLS"       ,
		"_MOTIF_WM_HINTS"    ,
		"_NET_WM_STATE"      ,
		"_NET_WM_STATE_ABOVE",
	};

	Atom array[ sizeof names / sizeof names[0] ];

	const size_t n = sizeof array / sizeof array[0];

	/*
		This function returns a nonzero status if atoms are
		returned for all of the names; otherwise, it returns zero.

		cast to second XInternAtoms argument is annoying, but...
	*/
	if ( (rtn = XInternAtoms(display, (char**)names, n, False, array)) == 0)
	{
		return -1;
	}

	/*
		This MUST be in sync with `names'
	*/
	i = 0;
	atoms.ATOM                = array[i++];
	atoms.WM_DELETE_WINDOW    = array[i++];
	atoms.WM_PROTOCOLS        = array[i++];
	atoms._MOTIF_WM_HINTS     = array[i++];
	atoms._NET_WM_STATE       = array[i++];
	atoms._NET_WM_STATE_ABOVE = array[i++];

	assert(i == n);

	return 1;
}
