/* $Id$ */

#ifndef XSFCAVE_REPLAY_H_HEADER
#define XSFCAVE_REPLAY_H_HEADER

typedef struct
{
	long seed;
	unsigned score; /* Not always available */
	unsigned tick_count;
	char user_updown[8000];
} ReplayClass;

extern const struct ReplayClassPublicMethods
{
    void  (*add_tick)      (ReplayClass *, Bool want_to_go_upwards);
    void  (*create)        (ReplayClass *, long seed);              
    void  (*destroy)       (ReplayClass *);                          
    Bool  (*load)          (ReplayClass *, FILE *);                  
    void  (*save)          (ReplayClass *, FILE *);                  
    char *(*save_as_string)(ReplayClass *);                          
    void  (*save_best)     (ReplayClass *);                          
    void  (*save_best_ever)(ReplayClass *);                          
    void  (*save_last)     (ReplayClass *);
} Replay;

#endif
