/* $Id: xsfcave.h,v 1.31 2006/01/31 01:16:17 ppl Exp $ */

#ifndef HEADER_XSFCAVE_H
#define HEADER_XSFCAVE_H

#include <assert.h>
#include <math.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
 
#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>

#include <unistd.h>

#include <libgen.h>

#include <X11/keysym.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Xmd.h>
#include <X11/Xutil.h>

#include "replay.h"
#include "screenshot.h"

/*
	Information about the X server
*/
extern Display *display;
extern Window root;
extern int screen;
extern unsigned int depth;

/*
	Command-line options.
*/
#ifdef DEBUG
extern Bool wflag;
extern double wflag_arg;
#endif

extern int score;
extern int high_score;
extern long randomnum; /* From game_engine.c */

#define GAME_WIDTH  130   /* width of the play area (game field) */
#define GAME_HEIGHT 130   /* how tall is the play area (game field) */
#define TICK_LENGTH (14*1000)  /* tick length in microseconds, smaller
                                 then a second */
#define WORM_LENGTH 30    /* Control how much of the worm we see */

#define GAME_DEFAULT_WORM_WEIGHT 0.05 /* How fast the worm falls */

#define COLOR_PURPLE "#8381FF"

#define BESTEVER_FILENAME "best_ever.xsfcave"
#define NICKNAME_FILENAME "nickname"

extern struct atoms
{
	Atom
	     ATOM               ,
	     WM_DELETE_WINDOW   ,
	     WM_PROTOCOLS       ,
	     _MOTIF_WM_HINTS    ,
	     _NET_WM_STATE      ,
	     _NET_WM_STATE_ABOVE;
} atoms;

unsigned long get_color(const char *colorName);

/*
	atom.c
*/
int atoms_init(void);

/*
	intro.c
*/
void intro_draw_frame(Drawable d);

/*
	cursor.c
*/
void cursor_hide(Window);
void cursor_show(Window);

/*
	submit_score.c
*/
void submit_score(const char *, const char *version, ReplayClass *, ScreenshotClass *);

/*
	version_check.c
*/
pid_t version_check(void);

#endif
